# webpack-plugin-cdn-qiniu

webpack将输出文件传到七牛云服务的封装

## Install

```bash
$ npm i webpack-plugin-cdn-qiniu --save-dev
```

## Conifg

```js
const webpack = require('webpack'); //to access built-in plugins
const QiniuCdnWebpack = require('webpack-plugin-cdn-qiniu')

module.exports = {
  module: {
    rules: [
      { test: /\.txt$/, use: 'raw-loader' }
    ]
  },
  plugins: [
    new QiniuCdnWebpack({
      cdn:{
        access_key:"access_key", // 七牛的access_key
        secret_key:"secret_key", // 七牛的secret_key
        bucket:"bucket" // 七牛的bucket
      },
      publicPath: "http://example.com", //七牛绑定的顶级域名地址
      prefixPath: "prefixPath", // 需要往cdn传递的url公共前缀
    })
    ...
  ]
};
``` 
> 如果遇到上传失败请尝试自定义上传配置

```js
const QiniuCdnWebpack = require('webpack-plugin-cdn-qiniu')
const qiniu = require('qiniu')
module.exports = {
  module: {
    rules: [
      { test: /\.txt$/, use: 'raw-loader' }
    ]
  },
  plugins: [
    new QiniuCdnWebpack({
      cdn:{
        options: {
          zone: qiniu.zone.Zone_z1
          ...
        }
        ...
      },
      ...
    })
    ...
  ]
};

``` 


## ignore

> 如果想排除个别文件不容许上传到cdn

1. 项目的根路径下新建文件：“.cdnignore” 规则和.gitignore是一样的
2. 注意配置的路径是项目的根路径。

> 例子：

```js
index.html
dist/statis/*
```

## Introduction

- 本插件仅支持一个cdn顶级地址。
- 或许会存在前缀配置和域名配置失效的问题，使用中出现问题请务必:[issue](https://github.com/MicahChiu/webpack-plugin-cdn-qiniu/issues)
- 本插件现有策略会在一旦发生任意某种原因失败则整个过程中断，保证发版的质量。
- 如果遇到打包输出并没有完全根据配置的扩展生成，需要自行检验下是否真的缺失了。


## Questions & Suggestions

Please open an issue [here](https://github.com/MicahChiu/webpack-plugin-cdn-qiniu/issues).

## License

[MIT](LICENSE)