"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var qiniu_1 = __importDefault(require("qiniu"));
var webpack_plugin_cdn_1 = require("webpack-plugin-cdn");
var QiniuCdnWebpack = /** @class */ (function (_super) {
    __extends(QiniuCdnWebpack, _super);
    function QiniuCdnWebpack(options) {
        var _this = _super.call(this, {
            outProgress: function (fileName, localFile) {
                _this.formUploader.putFile(_this.uploadToken, fileName, localFile, new qiniu_1.default.form_up.PutExtra(), function (err, respBody, respInfo) {
                    if (err)
                        throw new Error("Qiniu service upload failed. err: " + err);
                    if (respInfo.statusCode != 200)
                        throw new Error("Error uploading file statusCode: " + respInfo.statusCode + "respBody: " + respBody);
                    console.log("Cdn done => " + fileName);
                });
                return true;
            },
            publicPath: options.publicPath,
            prefixPath: options.prefixPath,
            ignorePath: options.ignorePath
        }) || this;
        if (webpack_plugin_cdn_1.VerifyJson(options) === false)
            throw new Error("Operation parameter validation failed");
        if (!options.cdn)
            throw new Error("Cdn is not define");
        if (!options.cdn.access_key)
            throw new Error("Access_key is not define");
        if (!options.cdn.secret_key)
            throw new Error("Secret_key is not define");
        if (!options.cdn.bucket)
            throw new Error("Bucket is not define");
        var QiniuUpdate = new qiniu_1.default.auth.digest.Mac(options.cdn.access_key, options.cdn.secret_key);
        var putPolicy = new qiniu_1.default.rs.PutPolicy({ scope: options.cdn.bucket });
        _this.uploadToken = putPolicy.uploadToken(QiniuUpdate);
        var config = new qiniu_1.default.conf.Config();
        if (options.cdn.options) {
            for (var key in options.cdn.options) {
                config[key] = options.cdn.options[key];
            }
        }
        _this.formUploader = new qiniu_1.default.form_up.FormUploader(config);
        return _this;
    }
    return QiniuCdnWebpack;
}(webpack_plugin_cdn_1.CdnWebpackPlugin));
module.exports = QiniuCdnWebpack;
